/* Betriebssystem & Middleware
 *
 * Betriebssystemarchitektur SS 2006
 *
 * Uebung 4.4 
 */
#include <stdio.h>
#include <errno.h>

#define XSIZE 500
#define YSIZE 500
#include "algorithm.h"

/* BMP Header 
unsigned char header[54]={0x42,0x4d,              // signature BM
                            0xe6,0x71,0x0b,0x0,   // filesize 750054
                            0x0,0x0,0x0,0x0,      // reserved 
                            0x36,0x0,0x0,0x0,     // image offset 54
                            0x28,0x0,0x0,0x0,     // size of header follows 40
                            0xf4,0x1,0x0,0x0,     // with of image 500
                            0xf4,0x1,0x0,0x0,     // height of image 500
                            0x1,0x0,              // number of planes  1
                            0x18,0x0,             // number of pixel 24
                            0x0,0x0,0x0,0x0,      // compression  
                            0xb0,0x71,0x0b,0x0,   // size of image 750000
                            0x0,0x0,0x0,0x0,      // xres
                            0x0,0x0,0x0,0x0,      // yres   
                            0x0,0x0,0x0,0x0,      // number of colortables    
                            0x0,0x0,0x0,0x0       // number of important colors
                        };
*/

int main(int argc, char *argv[])
{
    FILE *fd;
    int len,x,y;
    char bgr[3];
    short svalue;
    int   lvalue;
    unsigned char header[54],*ptr=&header[0];
      
    fd=fopen("test.bmp","wb+");
    if(NULL==fd)
    {
        perror("open"); exit(1);
    }
/* Der folgende Abschnitt dient nur zur information und kann durch 
    schreiben der auskommentierten Variable header ersetzt werden */    
    svalue=0x4d42;
    memcpy(ptr,&svalue,2);//signatur
    ptr+=2;
    lvalue=XSIZE*YSIZE*3+54;
    memcpy(ptr,&lvalue,4); //filesize
    ptr+=4;
    lvalue=0;
    memcpy(ptr,&lvalue,4);//reserved
    ptr+=4;
    lvalue=54;
    memcpy(ptr,&lvalue,4);//image offset
    ptr+=4;
    lvalue=40;
    memcpy(ptr,&lvalue,4);//size of header follows
    ptr+=4;
    lvalue=XSIZE;
    memcpy(ptr,&lvalue,4);//with of image
    ptr+=4;
    lvalue=YSIZE;
    memcpy(ptr,&lvalue,4); //height of image
    ptr+=4;
    svalue=1;
    memcpy(ptr,&svalue,2); //number of planes
    ptr+=2;
    svalue=24;
    memcpy(ptr,&svalue,2); //number of pixel
    ptr+=2;
    lvalue=0; //compression
    memcpy(ptr,&lvalue,4); //compression
    ptr+=4;
    lvalue=XSIZE*YSIZE*3; 
    memcpy(ptr,&lvalue,4); //size of image
    ptr+=4;
    lvalue=0;
    memcpy(ptr,&lvalue,4); //xres  
    ptr+=4;
    lvalue=0;
    memcpy(ptr,&lvalue,4); //yres
    ptr+=4;
    lvalue=0;
    memcpy(ptr,&lvalue,4); //number of colortables
    ptr+=4;
    lvalue=0;
    memcpy(ptr,&lvalue,4); //number of important colors
    ptr+=4;
/* Ende Information */

    len=fwrite(header,1,sizeof(header),fd); //write header
    
    if(-1==len || len!=sizeof(header))
    {
        perror("write");
        exit(2);
    }
    
    for(y=YSIZE-1;y>=0;y--)
    {
            for(x=0;x<XSIZE;x++)
            {
                getColorValuesAt(x * (2.0 / XSIZE) - 1.5, y * (2.0 / YSIZE) - 1.0,&bgr[2],&bgr[1],&bgr[0]); 
                
                len=fwrite(bgr,1,3,fd);
                if(-1==len || len!=3)
                {
                    perror("write");
                    exit(4);
                }
            }
            /*no padding required because 1500%4 =0*/
    }        
    fclose(fd);
    
}
